#pragma once
#include "CivAssembly.h"
#include "CivInpHelperAbs.h"
#include <memory>
#include "pandaDbManager.h"

/**
* 
*/
class PANDADBMANAGER_API CivProjInpDbHelper: public CivInpHelperAbs
{
public:
	explicit CivProjInpDbHelper(const std::string& uri);
	~CivProjInpDbHelper();

	void handlePump() override;
	void handleValve() override;

	bool getNode(CivNode& node) override;
	bool getPipe(CivPipe& pipe) override;
	bool getTank(CivTank& tank) override;
	bool getValve(CivValve& valve) override;
	bool getPumps(CivPumps& pump) override;
	bool getReservoirs(CivReservoirs& reservoirs) override;
	bool getCoordinates(CivCoordinates& coord) override;
	bool getQuality(CivQuality& quality) override;
	bool getStatus(CivStatus& status) override;

	void setProjCode(const std::string& projCode);

private:
	// ݰͼ
	void sortProjDeatil();


	std::string splicingSql(const std::string& rightTable, 
		const std::string& demandName = "ˮģʽ", 
		const std::string& demandPattern = "ˮ");

	// ݷɶӦͼͼsql
	std::string inline genSqlView(const std::string& table,
		const std::string& projTable,
		const std::vector<std::string>& fieldsVec,  
		const std::string& projCode);

	/**
	*@brief ͼ㶯̬Ҫѯ
	*/
	std::string inline splicingConditions(const std::string& layer);

	std::string inline genSql(const std::string& table);

	bool handleValves2();

	std::string mPorjCode;
	std::string mCondition;

	// ݷݻ
	std::map<std::string,std::vector<std::map<std::string,std::string>>>  mDetailMap;
};
